#include <iostream>
#include <cmath>
#include <iomanip>
#include <vector>
#include <set>
#include <algorithm>
#include <string>
using namespace std;

using ll = long long;

int main() {
	string ind;
	string cmd;
	cin >> ind;
	vector<vector<int>> tmp(101, vector<int>(26));
	vector<vector<bool>> changed(101, vector<bool>(26, 0));
	vector<int> v(26, 0);
	vector<bool> used(26, 0);
	while (ind != ".") {
		int idx = stoi(ind);
		cin >> cmd;
		if (cmd == "BEGIN") {
			tmp[idx] = v;
			fill(changed[idx].begin(), changed[idx].end(), 0);
		}
		else if (cmd == "COMMIT") {
			for (int i = 0; i < 26; ++i)
				if (changed[idx][i])
					v[i] = tmp[idx][i];
		}
		else if (cmd == "ROLLBACK") {
			cin >> ind;
			continue;
		}
		else {
			used[cmd[0] - 'A'] = 1;
			if (isalpha(cmd[2])) {
				used[cmd[2] - 'A'] = 1;
				tmp[idx][cmd[0] - 'A'] = tmp[idx][cmd[2] - 'A'] + stoi(cmd.substr(4));
			}
			else {
				tmp[idx][cmd[0] - 'A'] = stoi(cmd.substr(2));
			}
			changed[idx][cmd[0] - 'A'] = 1;
		}
		cin >> ind;
	}
	for (int i = 0; i < 26; ++i)
		if (used[i])
			cout << (char)('A' + i) << '=' << v[i] << '\n';
	return 0;
}