import math


start = tuple(map(int, input().split()))
n = int(input())
targets = [tuple(map(int, input().split())) for _ in range(n)]


def get_distance(d1, d2):
    x1, y1, z1 = d1
    x2, y2, z2 = d2
    return abs(x1 - x2) + abs(y1 - y2) + abs(z1 - z2)


path = [None] * n
visited = [False] * n
min_path = None
min_dist = math.inf

def rec(s=0, idx=0):
    global min_path, min_dist
    if idx == n:
        if s < min_dist:
            min_dist = s
            min_path = path[::]
    if s >= min_dist:
        return
    for i in range(n):
        if not visited[i]:
            visited[i] = True
            path[idx] = i
            if idx == 0:
                rec(s + get_distance(start, targets[i]), idx + 1)
            else:
                rec(s + get_distance(targets[path[idx - 1]], targets[i]), idx + 1)
    
            visited[i] = False


rec()
print(min_dist)
for v in min_path:
    print(v + 1)

