data = {}
processes_data = {}
changes = {}
while True:
    inp = input()
    if inp == '.':
        break
    n, action = inp.split()
    n = int(n)
    if action == 'BEGIN':
        processes_data[n] = data.copy()
        changes[n] = {}
    elif '=' in action:
        eq_i = action.index('=')
        x = action[:eq_i]
        if '+' in action:
            plus_i = action.index('+')
            y = action[eq_i + 1:plus_i]
            k = int(action[plus_i + 1:])
            processes_data[n][x] = processes_data[n].get(y, 0) + k
        else:
            k = int(action[eq_i + 1:])
            processes_data[n][x] = k
        changes[n][x] = processes_data[n][x]
    elif action == 'COMMIT':
        for key, val in changes[n].items():
            data[key] = val
    elif action == 'ROLLBACK':
        for key in changes[n]:
            data[key] = data.get(key, 0)
for key in sorted(data):
    print(key, data[key], sep='=')


            


