data = {}
processes_data = {}
used_changes = {}
used_values = {}
# {process: {var: (M, value)}}
last_changes = {}
changes = {}
lost_changes = []
while True:
    inp = input()
    if inp == '.':
        break
    n, *other = inp.split()
    if len(other) == 2:
        action, m = other
        m = int(m)
    else:
        action = other[0]
    n = int(n)
    if action == 'BEGIN':
        processes_data[n] = data.copy()
        used_changes[n] = last_changes.copy()
        used_values[n] = set()
        changes[n] = {}
    elif '=' in action:
        eq_i = action.index('=')
        x = action[:eq_i]
        if '+' in action:
            plus_i = action.index('+')
            y = action[eq_i + 1:plus_i]
            k = int(action[plus_i + 1:])
            processes_data[n][x] = processes_data[n].get(y, 0) + k
            used_values[n].add(x)  # !
            # used_values[n].add(y)
        else:
            k = int(action[eq_i + 1:])
            processes_data[n][x] = k
            used_values[n].add(x)  # !
        changes[n][x] = processes_data[n][x]
    elif action == 'COMMIT':
        for x in last_changes: 
            if (x in used_values[n] and 
                    used_changes[n].get(x) != last_changes.get(x) and 
                    x in last_changes):
                lost_changes += [(last_changes[x][0], x, last_changes[x][1])]
        for key, val in changes[n].items():
            data[key] = val
            last_changes[key] = (m, val)
    elif action == 'ROLLBACK':
        for key in changes[n]:
            data[key] = data.get(key, 0)
if lost_changes:
    for m, x, k in sorted(lost_changes):
        print(m, x, k)
else:
    print('NO')


            


