#include <bits/stdc++.h>
#define endd "\n"

using namespace std;

template<class T>
T read(){
    T t;
    cin >> t;
    return t;
}

int parse(const string& s, int begin, int end){
    int id = 0;
    for(auto it = begin; it != min((int)s.size(),end); it++){
        id*=10;
        id+=(int)(s[it]-'0');
    }
    return id;
}

int parse(const string& s){
    return parse(s, 0, s.size());
}

//При прогоне иногда возникают непредвиденные ошибки, связанные с багами компилятора. При двух последовательных запусках один может работать, а второй - нет

int main() {
    ios_base::sync_with_stdio(false);
    cin.tie();

    vector<vector<int>> resources(99,vector<int>('Z'-'A'+1,-1));
    vector<bool> used('Z'-'A'+1, false);
    for(char i = 0; i <= 'Z'-'A'+1; i++){
        resources[0][i] = 0;
    }
    while(true){
        string s1 = read<string>();
        if(s1[0] == '.')
            break;
        int num = parse(s1);
        string s2 = read<string>();
        if(s2 == "BEGIN"){
            for(int i = 0; i < 'Z'-'A'+1; i++){
                resources[num][i] = -1;
            }
        }else if(s2 == "COMMIT"){
            for(int i = 0; i < 'Z'-'A'+1; i++){
                if(resources[num][i] != -1)
                    resources[0][i] = resources[num][i];
            }
        }else if(s2 != "ROLLBACK"){
            int to = s2[0] - 'A';
            used[to] = true;
            if(s2[2] >= 'A' && s2[2] <= 'Z'){
                int from = s2[2] - 'A';
                used[from] = true;

                int from_v;
                if(resources[num][from] != -1)
                    from_v = resources[num][from];
                else
                    from_v = resources[0][from];

                resources[num][to] = from_v + parse(s2,4,s2.size());
            }else{
                resources[num][to] = parse(s2,2,s2.size());
            }
        }
    }
    for(int i = 0; i < 'Z'-'A'+1; i++){
        if(used[i])
            cout << (char)('A'+i) << "=" << resources[0][i] << endd;
    }
    cout.flush();
    return 0;
}
