#include <bits/stdc++.h>
#define ll long long

using namespace std;

const int MAXN = 1e5;

ll n, n1, n2;
vector< vector<ll> > v;
vector<string> sc;
vector<string> now;

string st(ll a) {
    string res = "";
    while (a) {
        res = ((char)(a % 10 + '0')) + res;
        a /= 10;
    }
    return res;
}

void dfs(ll u) {
    ll d = u;
    if (d > n1 + n) {
        d -= n1 + n;
    } else if (d > n) {
        d -= n;
    }
    now.push_back(st(d));
    now.push_back(sc[u]);
    for (ll i : v[u]) {
        dfs(i);
    }
    if (v[u].size() == 0) {
        for (string j : now) {
            cout << j << " ";
        }
        cout << '\n';
    }
    now.pop_back();
    now.pop_back();
}

int main() {
    cin >> n;
    v.resize(MAXN);
    sc.resize(MAXN);
    for (int i=0; i < n; ++i) {
        ll id;
        string s;
        cin >> id >> s;
        sc[id] = s;
    }
    cin >> n1;
    for (int i=0; i < n1; ++i) {
        ll d1, d2;
        string c;
        cin >> d1 >> d2 >> c;
        sc[d1 + n] = c;
        v[d2].push_back(d1 + n);
    }
    cin >> n2;
    for (int i=0; i < n2; ++i) {
        ll d1, d2;
        string s1, s2;
        cin >> d1 >> d2 >> s1 >> s2;
        string d = s1 + " " + s2;
        sc[d1 + n + n1] = d;
        v[d2 + n].push_back(d1 + n + n1);
    }
    for (int i=0; i < MAXN; ++i) {
        sort(v[i].begin(), v[i].end());
    }
    for (int i=0; i < n; ++i) {
        dfs(i + 1);
    }
}
