#ifdef ON_PC
#define _GLIBCXX_DEBUG
#endif

#include <bits/stdc++.h>

bool is_palindrome(const std::string& s) {
    for (size_t i = 0; i < s.size() / 2; i++) {
        if (s[i] != s[s.size() - i - 1]) {
            return false;
        }
    }

    return true;
}

int main() {
    std::ios_base::sync_with_stdio(false);
    std::cin.tie(nullptr);

    size_t n;
    std::cin >> n;

    std::vector<std::string> strings(n);
    for (auto &item: strings) {
        std::cin >> item;
    }

    std::set<std::string> final;

    for (int64_t i = 0; i < (1 << n); i++) {
        std::vector<std::string> current;

        for (int64_t j = 0; j < n; j++) {
            if (i & (1 << j)) {
                current.emplace_back(strings[j]);
            }
        }

        if (current.empty()) continue;

        do {
            std::string s;
            for (const auto &item: current) {
                s += item;
            }
            if (is_palindrome(s)) {
                final.insert(s);
            }
        } while (std::next_permutation(std::begin(current), std::end(current)));
    }

    std::cout << final.size();

#ifdef ON_PC
    std::cerr << "\n" << static_cast<double>(std::clock()) / CLOCKS_PER_SEC << "\n";
#endif

    return 0;
}

