#include <iostream>
#include <vector>
#include <set>
#include <map>
#include <string>
#include <algorithm>
#include<bits/stdc++.h>
#include<fstream>

using namespace std;

struct query{
    int proc;
    char res;
    char t;
    query (int a, char b, char c){
        this->proc = a;
        this->res = b;
        this->t=c;
    }
    query(){
        this->proc = this->res = this->t = 0;
    }
};

int main()
{
    //ifstream fin("f.txt");
    vector<query> queries;
    while(true){
        string s;
        //fin >> s;
        cin >> s;
        if(s == ".") break;
        int a = 0;
        int n = s.size();
        for (int i = 0; i< n; ++i){
            a*=10;
            a+=(s[i] - '0');
        }
        char res;
        cin >> res;
        //fin >> res;
        char type;
        //fin >> type;
        cin >> type;
        queries.push_back(query(a, res, type));
    }
    int k = queries.size();
    vector< vector<int> > blocked(26);
    vector<int> blocked_type(26);
    vector< vector<int> > wait(102);
    vector<int> wait_time(102);
    for (int i =0;i <k; ++i){
        query q = queries[i];
        int proc = q.proc;
        char res = q.res;
        char t =q.t;
        wait[proc].clear();
        if(t == 'U'){
            if(blocked_type[res - 'A']== 2){
                blocked[res - 'A'].clear();
                blocked_type[res - 'A']= 0;
            } else {
                blocked[res - 'A'].erase(find(blocked[res - 'A'].begin(), blocked[res - 'A'].end(), proc));
            }
        }
        else if (t == 'R'){
            if(blocked_type[res - 'A'] == 1 || blocked_type[res - 'A'] == 0){
                blocked_type[res - 'A'] = 1;
                blocked[res - 'A'].push_back(proc);
            } else {
                wait[proc].push_back(blocked[res - 'A'].front());
                wait_time[proc] = i;
            }
        } else {
            if(blocked_type[res - 'A'] ==0){
                blocked_type[res - 'A'] = 2;
                blocked[res - 'A'].push_back(proc);
            } else {
                int sz = blocked[res - 'A'].size();
                for (int j = 0; j < sz; ++j)wait[proc].push_back(blocked[res - 'A'][j]);
                wait_time[proc] = i;
            }
        }
    }
    vector<bool> checked(102);
    map <int, vector<int> > deadlocks;
    for (int i=1; i <= 100;++i){
        if(checked[i])continue;
        int cur = i;
        vector<bool> visited(102);
        vector<int> _v;
        int sz = wait[cur].size();
        while(sz != 0 && !visited[cur]){
            _v.push_back(cur);
            visited[cur] =1;
            sz = wait[cur].size();
            if(sz !=1){
                int mn = 1e9, mncur = 0;
                for (int j = 0; j < sz; ++j){
                    if(visited[wait[cur][j]] && wait_time[wait[cur][j]] < mn){
                        mn = wait_time[wait[cur][j]];
                        mncur = wait[cur][j];;
                        //break;
                    }
                }
                cur = mncur;
                break;
            }
            cur = wait[cur].front();
        }
        if(visited[cur]){
            checked[i]= 1;
            checked[cur]= 1;
            vector<int> v;
            int it = 0;
            int sz = _v.size();
            while(_v[it] != cur && it < sz) ++it;
            v.push_back(cur);
            ++it;
            while(_v[it] != cur && it < sz){
                v.push_back(_v[it]);
                ++it;
            }
            sort(v.begin(), v.end());
            deadlocks[wait_time[cur]] = v;
        }
    }
    if(deadlocks.size() == 0){
        cout << "NO DEADLOCK" << endl;
        int cnt = 0;
        for (int i = 0; i < 26; ++i){
            if(blocked[i].size() != 0) ++cnt;
        }
        cout << cnt;
    } else{
        vector<int> v = deadlocks.begin()->second;
        //cout << deadlocks.begin()->first << endl;
        int cnt = v.size();
        cout << "DEADLOCK" << endl;
        for (int i = 0; i < cnt; ++i) cout << v[i] << " ";
    }
    return 0;
}
