class Process:
    def __init__(self,res,id):
        self.resources = res.copy()
        self.id = id
        self.changes = []
    def change(self,command):
        toChange = command[0]
        if(command[2] in "0123456789"):
            self.resources[toChange] = int(command[2:])
        else:
            additive = command[2]
            self.resources[toChange] = self.resources.get(additive,0)+int(command[4:])
        if(toChange not in self.changes): self.changes.append(toChange)
    def commit(self):
        res = {}
        for changed in self.changes:
            res[changed] = self.resources[changed]
        return res

resources = {}
processes = {}
callbacks = {}
overrided = []
inp = ""
while inp!=".":
    inp = input()
    if inp == "": continue
    if inp==".": break
    parameters = inp.split()
    id,command = parameters[0],parameters[1]
    transID = "N/A"
    if(len(parameters)>=3):
        transID = parameters[2]
    if(command=="BEGIN"):
        processes[id] = Process(resources, transID)
    elif(command=="COMMIT"):
        commt = processes.pop(id).commit()
        #print(commt)
        for S in commt.keys():
            if(callbacks.get(S,"")!=""):
                overrided.append(" ".join([callbacks[S],S,str(resources[S])]))
            resources[S] = commt[S]

            callbacks[S] = transID

    elif (command == "ROLLBACK"):
        processes.pop(id)
    else:
        if(resources.get(command[0],-1)==-1): resources[command[0]]=0
        if(command[2] not in "0123456789"):
            if (resources.get(command[2], -1) == -1): resources[command[2]] = 0
        processes[id].change(command)
overrided = list(sorted(overrided))
#print(resources)
if(len(overrided)==0): print("NO")
for O in overrided:
    print(O)