#include <bits/stdc++.h>

using namespace std;

using ll = long long;
using ld = long double;

int main() {
    int n, m, k;
    cin >> n >> m >> k;

    set<pair<pair<int, int>, pair<int, int> > > regs = {make_pair(make_pair(0, 0), make_pair(n - 1, m - 1))};

    for (int i = 0; i < k; ++i) {
        int y, x, v;
        cin >> y >> x >> v, --y, --x;

        set<pair<pair<int, int>, pair<int, int> > > _regs;
        for (auto& quad: regs) {
            int y1 = quad.first.first, x1 = quad.first.second, y2 = quad.second.first, x2 = quad.second.second;

            int flag = 1;
            if (y1 <= y && x1 <= x) {
                if (y2 >= y && x2 >= x) {
                    flag = 0;
                    if (x > 0 && x1 <= x - 1) _regs.insert(make_pair( make_pair(y1, x1), make_pair(y2, x - 1) ));
                    if (x < n - 1 && x + 1 <= x2) _regs.insert(make_pair( make_pair(y1, x + 1), make_pair(y2, x2) ));
                    if (y > 0 && y1 <= y - 1) _regs.insert(make_pair( make_pair(y1, x1), make_pair(y - 1, x2) ));
                    if (y < n - 1 && y + 1 <= y2) _regs.insert(make_pair( make_pair(y + 1, x1), make_pair(y2, x2) ));
                }
            }

            if (flag) _regs.insert(quad);
        }

        regs = _regs;
    }
    int max_area = -1e9;
    int _y1, _x1, _y2, _x2;
    for (auto& quad: regs) {
        int y1 = quad.first.first, x1 = quad.first.second, y2 = quad.second.first, x2 = quad.second.second;
        if ((y2 - y1 + 1) * (x2 - x1 + 1) > max_area) {
            _y1 = y1;
            _x1 = x1;
            _y2 = y2;
            _x2 = x2;
            max_area = (y2 - y1 + 1) * (x2 - x1 + 1);
        }
    }

    cout << _y1 + 1 << " " << _x1 + 1 << endl << _y2 + 1 << " " << _x2 + 1<< endl;
    return 0;
}
