#include <bits/stdc++.h>

using namespace std;

using ll = long long;
using ld = long double;

vector<int> locks(26, -1);
vector<queue<int>> block_queue(26);
vector<set<int>> block_set(26);
vector<int> graph(101, -1);

int flag;
void dfs(int v, vector<int>& color, vector<int>& current, int cc) {
    current.push_back(v);
    if (color[v] > -1) {
        if (color[v] == cc) flag = 1;
        return;
    }

    color[v] = cc;

    if (graph[v] > -1) {
        dfs(graph[v], color, current, cc);
    }
}

int main() {
    string inpt;
    vector<int> arr;
    set<int> ans;
    int _flag = 1;
    while (1) {
        getline(cin, inpt);
        if (inpt[0] =='.') break;

        int id = 0;
        int name;
        char type;
        int pos = 0;
        for (int i = 0; i < inpt.size() && inpt[i] - '0' < 10 && inpt[i] - '0' > -1; ++i) {
            id = id * 10 + inpt[i] - '0';
            pos = i;
        }
        --id;
        name = inpt[pos + 2] - 'A';
        type = inpt[pos + 4];

        if (type == 'L') {
            if (locks[name] == -1) {
                locks[name] = id;
            }
            else {
                graph[id] = locks[name];

                block_queue[name].push(id);
                block_set[name].insert(id);
            }
        }
        else {
            int before = locks[name];
            locks[name] = -1;

            for (int i = 0; i < 101; ++i) {
                if (graph[i] == before) {
                    graph[i] = -1;
                }
            }
            int next;
            if (!block_queue[name].empty()) {
                next = block_queue[name].front();
                graph[next] = -1;
                block_queue[name].pop();
                block_set[name].erase(next);

                locks[name] = next;
                for (auto& i: block_set[name]) {
                    graph[i] = next;
                }
            }
        }

        if (_flag) {
            flag = 0;
            vector<int> color(101, -1);
            for (int i = 0; i < 101; ++i) {
                if (color[i] == -1) {
                    vector<int> current;
                    dfs(i, color, current, i);
                    if (flag) {
                        _flag = 0;
                        for (auto& i: current) ans.insert(i);
                        break;
                    }
                }
            }
        }
    }
    if (_flag) {
        int counter = 0;
        for (int i = 0; i < 26; ++i) if (locks[i] > -1) ++counter;
        cout << "NO DEADLOCK" << endl << counter;
    }
    else {
        cout << "DEADLOCK" << endl;
        for (auto& i: ans) cout << i + 1 << " ";
    }

    return 0;
}
