##from random import randint

def distance(a, b):
    return abs(a[0]-b[0])+abs(a[1]-b[1])+abs(a[2]-b[2])

def in_b(a, b, c):
    return (a >= b >= c) or (a <= b <= c)

def in_bp(a, b, c):
    return all(in_b(a[i], b[i], c[i]) for i in range(3))

def solve():
    x, y, z = map(int, input().split())
    start = (x, y, z)
    n = int(input())
    points = []
    for i in range(n):
        x, y, z = map(int, input().split())
        points.append((x, y, z, i))

    dist = [[None]*n for _ in range(n)]

    for i in range(n):
        for j in range(i+1, n):
            dist[j][i] = dist[i][j] = distance(points[i], points[j])
            if i == j: continue
            for k in range(n):
                if i==k: continue
                if j==k: continue
                if in_bp(points[i], points[k], points[j]):
                    dist[j][i] = dist[i][j] = None
                    break

    m_d = [1000]
    m_p = [None]

    def dfs(cur, d, path=[]):
        if len(path) == n:
            m_d[0] = d
            m_p[0] = path
            return

        if d >= m_d[0]:
            return
        
        for i in range(n):
            if not dist[cur][i]: continue
            if i in path: continue
            dfs(i, d + dist[cur][i], path + [i])

    for i in range(n):
        dfs(i, distance(points[i], start), path=[i])

    print(m_d[0])
    for i in m_p[0]:
        print(i + 1)
##
##def g():
##    return randint(1, 10)
##
##def test(n):
##    print(g(), g(), g())
##    print(n)
##    for _ in range(n):
##        print(g(), g(), g())

if __name__ == "__main__":
##    test(10)
    solve()
