#include <iostream>
#include <vector>
#include <string>
#include <map>
#include <cctype>
#include <algorithm>
#include <sstream>
using namespace std;

#define SZ(sp) int(sp.size())
#define all(sp) sp.begin(), sp.end()
#define mp make_pair
#define fi first
#define se second

int main() {
    vector < map < string, int > > proc(100);
    vector < pair < int, map < string, pair < int, int > > > > time;
    vector < int > start(100), sp_tr(100);
    map < int, int > num_tr;
    time.emplace_back(0, map < string, pair < int, int > > ());
    string s;
    stringstream sx;
    int tt = 1;
    pair < int, map < string, pair < int, int > > > p = time[0];
    while (getline(cin, s)) {
        if (s == ".") {
            break;
        }
        int tr;
        string s_tr = "", req = "";
        for (int i = 0; i < SZ(s); ++i) {
            if (s[i] == ' ') {
                sx << s_tr;
                sx >> tr;
                sx.clear();
                for (int j = i + 1; j < SZ(s); ++j) {
                    req += s[j];
                }
                break;
            } else {
                s_tr += s[i];
            }
        }
        int tr2 = -1;
        if (req.find("=") == std::string::npos) {
            int pos = req.find(" ");
            string req2 = "", ch = "";
            for (int i = 0; i < SZ(req); ++i) {
                if (i < pos) {
                    req2 += req[i];
                } else if (i > pos) {
                    ch += req[i];
                }
            }
            sx << ch;
            sx >> tr2;
            sx.clear();
            req = req2;
            num_tr[tr] = tr2;
        }
        if (req == "BEGIN") {
            start[num_tr[tr]] = tt;
        } else if (req == "ROLLBACK") {
            proc[num_tr[tr]].clear();
        } else if (req == "COMMIT") {
            for (auto &el : time.back().second) {
                if (proc[num_tr[tr]].find(el.first) == proc[num_tr[tr]].end()) {
                    el.second.second = 1;
                }
            }
            time.emplace_back(tt, time.back().second);
            num_tr[tt] = num_tr[tr];
            for (auto &el : proc[num_tr[tr]]) {
                time.back().second[el.first] = mp(el.second, 0);
            }
            proc[num_tr[tr]].clear();
        } else {
            string name1 = "", name2 = "";
            int i = 0;
            for (; i < SZ(req); ++i) {
                if (req[i] == '=') {
                    ++i;
                    break;
                }
                name1 += req[i];
            }
            if (req.find("+") != std::string::npos) {
                for (; i < SZ(req); ++i) {
                    if (req[i] == '+') {
                        ++i;
                        break;
                    }
                    name2 += req[i];
                }
            }
            int cnt = 0;
            string s_cnt = "";
            for (; i < SZ(req); ++i) {
                s_cnt += req[i];
            }
            sx << s_cnt;
            sx >> cnt;
            sx.clear();
            if (SZ(name2) == 0) {
                if (time.back().second.find(name1) == time.back().second.end()) {
                    time.back().second[name1] = mp(0, 1);
                }
                proc[num_tr[tr]][name1] = cnt;
            } else {
                if (time.back().second.find(name1) == time.back().second.end()) {
                    time.back().second[name1] = mp(0, 1);
                }
                if (time.back().second.find(name1) == time.back().second.end()) {
                    time.back().second[name2] = mp(0, 1);
                }
                int a = 0;
                if (proc[num_tr[tr]].find(name2) == proc[num_tr[tr]].end()) {
                    p.first = start[num_tr[tr]];
                    int pos = upper_bound(all(time), p) - time.begin();
                    --pos;
                    if (time[pos].second.find(name2) != time[pos].second.end()) {
                        a = time[pos].second[name2].first;
                        time[pos].second[name2].second = 1;
                    }
                } else {
                    a = proc[num_tr[tr]][name2];
                }
                proc[num_tr[tr]][name1] = a + cnt;
            }
        }
        ++tt;
    }
    vector < pair < int, pair < string, int > > > ans;
    for (int i = 1; i < SZ(time) - 1; ++i) {
        for (auto &el : time[i].second) {
            if (el.se.se == 0) {
                ans.emplace_back(mp(num_tr[time[i].first], mp(el.first, el.second.first)));
            }
        }
    }
    if (SZ(ans) == 0) {
        cout << "NO";
    } else {
        sort(all(ans));
        for (auto &el : ans) {
            cout << el.first << ' ' << el.second.first << ' ' << el.second.second << '\n';
        }
    }
}
/*
1 BEGIN
1 A=5
2 BEGIN
1 B=1
2 B=A+10
1 COMMIT
2 COMMIT
.
*/

/*
1 BEGIN
2 BEGIN
1 A=B+1
2 B=A+2
1 B=A+3
2 A=B+4
3 BEGIN
3 C=5
1 COMMIT
3 B=A+10
2 COMMIT
3 A=B+20
3 ROLLBACK
.
*/
/*
1 BEGIN 5
1 A=5
2 BEGIN 7
1 B=1
2 B=A+10
1 COMMIT 5
2 COMMIT 7
.
 */
/*
1 BEGIN 1
2 BEGIN 2
1 A=B+1
2 B=A+2
1 B=A+3
2 A=B+4
3 BEGIN 3
3 C=5
1 COMMIT 1
3 B=A+10
2 COMMIT 2
3 A=B+20
3 ROLLBACK 3
.
 */
