#include <iostream>
#include <vector>
#include <map>
#include <algorithm>
#include <string>

#define int long long

std::map<std::string, std::string> mp_2;
std::map<std::string, std::string> mp_16;
signed main() {
    std::ios_base::sync_with_stdio(0);
    std::cin.tie(0);
    std::cout.tie(0);

    std::vector<bool> end(110), start(110);
    std::vector<std::vector<int>> number(110, std::vector<int>(28));
    std::vector<std::vector<bool>> used(110, std::vector<bool>(28));
    std::vector<int> good_number(28);
    std::vector<bool> used_let(28);
    //std::vector<int> number(28);
    std::string cur;
    while (std::getline(std::cin, cur)) {
        //std::cout << cur << std::endl;
        if (cur == ".") {
            //std::cout << "a" << std::endl;
            break;
        }
        int pt = 0;
        cur += ' ';
        std::string type = "", command = "";
        while (cur[pt] != ' ') {
            type += cur[pt];
            ++pt;
        }
        ++pt;
        while (cur[pt] != ' ') {
            command += cur[pt];
            ++pt;
        }
        //std::cout << type << std::endl << command << std::endl;
        int num = std::stoi(type);
        if (command == "BEGIN") {
            //std::cout << num << std::endl;
            start[num] = true;
        } else if (command == "COMMIT") {
            //int num = std::stoi(type);
            end[num] = true;
            for (int i = 0; i < 28; ++i) {
                if (used[num][i]) {
                    good_number[i] = number[num][i];
                    //std::cout << num << " " << i << " " << number[num][i] << '\n';
                }
            }
            for (int i = 0; i < 28; ++i) {
                used[num][i] = false;
                number[num][i] = 0;
            }
        } else if (command == "ROLLBACK") {
            end[num] = true;
            for (int i = 0; i < 28; ++i) {
                number[num][i] = 0;
                used[num][i] = false;
            }
        } else {
            char upd = command[0];
            used_let[upd - 'A'] = true;
            used[num][upd - 'A'] = true;
            int pt = 2;
            if (command[2] >= 'A' && command[2] <= 'Z') {
                if (used[num][command[2] - 'A']) {
                    number[num][upd - 'A'] = number[num][command[2] - 'A'];
                } else {
                    number[num][upd - 'A'] = good_number[command[2] - 'A'];
                }
                pt = 4;
            }
            std::string upd_number = "";
            for (int i = pt; i < command.size(); ++i) {
                upd_number += command[i];
            }
            //std::cout << upd_number << std::endl;
            int upd_number_ = std::stoi(upd_number);
            //std::cout << num << " " << upd << " " << upd_number_ << std::endl;
            number[num][upd - 'A'] += upd_number_;

        }
    }
    for (int i = 0; i < 28; ++i) {
        if (used_let[i]) {
            std::cout << char(i + (int)'A')<< "=" << good_number[i] << '\n';
        }
    }

}