#include <bits/stdc++.h>
#define endd "\n"

using namespace std;

typedef unsigned long long ull;
typedef long long ll;

template<class T>
T read(){
    T t;
    cin >> t;
    return t;
}

ll dis(ll x1, ll y1, ll z1, ll x2, ll y2, ll z2){
    return abs(x2-x1)+abs(y2-y1)+abs(z2-z1);
}

struct point{
    ll x, y, z;
    point(ll x, ll y, ll z) : x(x), y(y), z(z) {}
};

ll dis(point p1, point p2){
    return dis(p1.x,p1.y,p1.z, p2.x,p2.y,p2.z);
}
int main() {
    ios_base::sync_with_stdio(false);
    cin.tie();

    ll x = read<ll>(), y = read<ll>(), z = read<ll>();
    ll N = read<ll>();
    vector<point> points;
    points.emplace_back(x,y,z);
    vector<vector<ll>> paths(N + 1, vector<ll>(N + 1, 0));
    for(ll i = 1; i <= N; i++){
        ll x1 = read<ll>(), y1 = read<ll>(), z1 = read<ll>();
        point p(x1,y1,z1);
        for(ll j = 0; j < i; j++){
            ll d = dis(p, points[j]);
            paths[i][j] = d;
            paths[j][i] = d;
        }
        points.emplace_back(p);
    }

    vector<ll> ans;
    vector<bool> visited(N+1, false);
    ll current = 0;
    ll dis = 0;
    while (ans.size() != N){
        visited[current] = true;
        ll v = 0, distance = 1000000;
        for(int i = 1; i <= N; i++){
            if(visited[i])
                continue;
            if(distance >= paths[current][i]){
                v = i;
                distance = paths[current][i];
            }
        }
        ans.emplace_back(v);
        dis += distance;
        current = v;
    }
    cout << dis << endd;
    for(auto i : ans)
        cout << i << endd;
    cout.flush();
    return 0;
}
