#include <iostream>
#include <vector>
#include <set>
#include <map>
#include <string>
#include <algorithm>
#include<bits/stdc++.h>
#include<fstream>

using namespace std;

struct c{
    string name;
    int id;
    c(string _n, int _id) {
        this->name = _n;
        this->id=_id;
    }
};

struct man{
    int id;
    string a, b;
    man(int _id, string _a, string _b){
        this->id = _id;
        this->a = _a;
        this->b =_b;
    }
};

bool class_comp(c a, c b){
    return a.id <b.id;
}

bool man_comp(man a, man b){
    return a.id <b.id;
}

int main()
{
    //ifstream fin("f.txt");
    map<int, string> schools;
    map<int,vector<c> > classes;
    map<int, vector<man> >pupils;
    int n;
    cin>> n;
    //fin >> n;
    for (int i = 0; i <n; ++i){
        int id;
        string name;
        cin >> id >> name;
        //fin >> id >> name;
        schools[id] =name;
    }
    cin >> n;
    //fin >> n;
    for (int i = 0; i <n; ++i){
        int id, school_id;
        string name;
        cin >> id >>school_id >> name;
        // >> id >>school_id >> name;
        classes[school_id].push_back(c(name, id));
    }
    cin >> n;
    //fin >> n;
    for (int i = 0; i <n; ++i){
        int id, class_id;
        string a, b;
        cin >> id >>class_id >> a >> b;
        //fin >> id >>class_id >> a >> b;
        pupils[class_id].push_back(man(id, a, b));
    }
    map<int, string>::iterator s= schools.begin();
    for (;s != schools.end();++s){
        int school_id = s->first;
        vector<c> classes_list= classes[school_id];
        int cnt = classes_list.size();
        if(cnt == 0){
            cout << school_id << " ";
            cout << s->second;
            cout << endl;
            continue;
        }
        sort(classes_list.begin(), classes_list.end(), class_comp);
        for (int i = 0; i < cnt;++i){
            int class_id = classes_list[i].id;
            vector<man> p = pupils[class_id];
            int k = p.size();
            if(k== 0){
                cout << school_id << " " << s->second << " ";
                cout << class_id << " ";
                cout << classes_list[i].name << endl;
                continue;
            }
            sort(p.begin(), p.end(), man_comp);
            for (int j = 0;j < k;++j){
                cout << school_id << " " << s->second << " ";
                cout << class_id << " ";
                cout << classes_list[i].name << " ";
                cout << p[j].id << " " << p[j].a << " " << p[j].b <<" ";
                cout << endl;
            }
        }
    }
    return 0;
}
