#include <iostream>
#include <vector>
#include <set>
#include <map>
#include <string>
#include <algorithm>
#include<bits/stdc++.h>
#include<fstream>

using namespace std;

struct query{
    int proc;
    char res;
    char t;
    query (int a, char b, char c){
        this->proc = a;
        this->res = b;
        this->t=c;
    }
    query(){
        this->proc = this->res = this->t = 0;
    }
};

int main()
{
    //ifstream fin("f.txt");
    vector<query> queries;
    while(true){
        string s;
        //fin >> s;
        cin >> s;
        if(s == ".") break;
        int a = 0;
        int n = s.size();
        for (int i = 0; i< n; ++i){
            a*=10;
            a+=(s[i] - '0');
        }
        char res;
        cin >> res;
        //fin >> res;
        char type;
        //fin >> type;
        cin >> type;
        queries.push_back(query(a, res, type));
    }
    int k = queries.size();
    vector<int> blocked(26);
    vector<int> wait(102);
    vector<int> wait_time(102);
    for (int i =0;i <k; ++i){
        query q = queries[i];
        int proc = q.proc;
        char res = q.res;
        char t =q.t;
        wait[proc] =0;
        if(t == 'U'){
            blocked[res - 'A'] = 0;
        }
        else{
            if(!blocked[res - 'A']){
                blocked[res- 'A'] = proc;
            }else {
                wait[proc] = blocked[res -'A'];
                wait_time[proc] =i;
            }
        }
    }
    vector<bool> checked(102);
    map <int, vector<int> > deadlocks;
    for (int i=1; i <= 100;++i){
        if(checked[i])continue;
        int cur = i;
        vector<bool> visited(102);
        int prev = cur;
        vector<int> _v;
        while(cur != 0 && !visited[cur]){
            _v.push_back(cur);
            visited[cur] =1;
            checked[cur] =1;
            prev = cur;
            cur = wait[cur];
        }
        if(visited[cur]){
            vector<int> v;
            int it = 0;
            int sz = _v.size();
            while(_v[it] != cur && it < sz) ++it;
            v.push_back(cur);
            ++it;
            while(_v[it] != cur && it < sz){
                v.push_back(_v[it]);
                ++it;
            }
            sort(v.begin(), v.end());
            //cout << cur << endl;
            deadlocks[wait_time[cur]] = v;
        }
    }
    if(deadlocks.size() == 0){
        cout << "NO DEADLOCK" << endl;
        int cnt = 0;
        for (int i = 0; i < 26; ++i){
            if(blocked[i] != 0) ++cnt;
        }
        cout << cnt;
    } else{
        vector<int> v = deadlocks.begin()->second;
        int cnt = v.size();
        cout << "DEADLOCK" << endl;
        for (int i = 0; i < cnt; ++i) cout << v[i] << " ";
    }
    return 0;
}
