#include <bits/stdc++.h>

using namespace std;

#define F first
#define S second
#define all(x) (x).begin(), (x).end()
typedef long long ll;

ll ok = 1;
void dfs(ll v, ll col, vector<ll> &go, vector<ll> &comps){
    comps[v] = col;
    if(go[v] == 1000){
        return;
    }
    if(go[v] == -1){
        ok = 0;
        return;
    }
    if(comps[go[v]]){
        ok = 0;
        return;
    }
    dfs(go[v], col, go, comps);
}

int main() {
#ifdef DEBUG
    freopen("input.txt", "r", stdin);
    freopen("output.txt", "w", stdout);
#endif
    ios_base::sync_with_stdio(false);
    cin.tie(0);
    cout.tie(0);

    ll n;
    cin >> n;
    vector<ll> go (n);
    for(ll i = 0; i < n; i ++){
        cin >> go[i];
        if(go[i] != 1000){
            go[i] --;
        }
    }
    ll m;
    cin >> m;
    vector<string> names (m), bad;
    vector<ll> start (m), comps (n);
    for(ll i = 0; i < m; i ++){
        cin >> names[i] >> start[i];
        start[i] --;
    }
    ll col = 1;
    for(ll i = 0; i < m; i ++){
        if(!comps[start[i]]){
            ok = 1;
            dfs(start[i], col, go, comps);
            col ++;
            if(!ok){
                bad.push_back(names[i]);
            }
        }
    }
    vector<ll> unused;
    for(ll i = 0; i < n; i ++){
        if(go[i] != -1 && !comps[i]){
            unused.push_back(i);
        }
    }
    sort(all(bad));
    cout << bad.size() << "\n";
    for(string &name: bad){
        cout << name << "\n";
    }
    cout << unused.size() << "\n";
    for(ll x: unused){
        cout << x + 1 << "\n";
    }
    return 0;
}