#include <iostream>
#include <vector>
#include <map>
#include <queue>
#include <stack>
#include <algorithm>
#include <cmath>
#include <climits>
#include <string>
typedef long long ll;
typedef double db;

const int INF = 1e9;

using namespace std;

bool solve( int a ){

    int len = 0;
    while( (1 << len) <= a ){
        len++;
    }

    int last = a % 2;
    bool ans = true;
    for( int i = 1; i < len; ++i ){
        if( ((a >> i) & 1 ) != !last ) ans = false;
        last = ((a >> i) & 1 );
    }

    return ans;
}

int main()
{

    int a;
    cin >> a;

    if( solve(a) ){
        cout << "YES\n";
    } else{
        cout << "NO\n";
    }

    return 0;
}
