#include <iostream>
#include <vector>
#include <map>
#include <queue>
#include <stack>
#include <algorithm>
#include <cmath>
#include <climits>
#include <string>
typedef long long ll;
typedef double db;

const int INF = 1e9;

using namespace std;

struct human{
    string firstname, lastname;
};

struct form{
    string name;
    map<int, human> p;
};

struct school{
    string name;
    map<int, form> f;
};



int main()
{

    int s;
    cin >> s;

    map<int, school> sc;
    map<int, int> f_to_sc;

    for( int i = 0; i < s; ++i ){
        int ids;
        cin >> ids;
        cin >> sc[ids].name;
    }

    int c;
    cin >> c;

    for( int i = 0; i < c; ++i ){
        int idc, ids;
        cin >> idc >> ids;
        f_to_sc[idc] = ids;
        cin >> sc[ids].f[idc].name;
    }

    int p;
    cin >> p;

    for( int i = 0; i < p; ++i ){
        int idp, idc;
        cin >> idp >> idc;
        int ids = f_to_sc[idc];
        cin >> sc[ids].f[idc].p[idp].lastname >> sc[ids].f[idc].p[idp].firstname;
    }

     for( map<int, school>::iterator it1 = sc.begin(); it1 != sc.end(); ++it1 ){
        if( it1->second.f.empty() ){
            cout << it1->first << ' ' << it1->second.name << '\n';
            continue;
        }

        for(  map<int, form>::iterator it2 = it1->second.f.begin(); it2 != it1->second.f.end(); ++it2 ){
            if( it2->second.p.empty() ){
                cout << it1->first << ' ' << it1->second.name << ' ';
                cout << it2->first << ' ' << it2->second.name << '\n';
                continue;
            }

             for(  map<int, human>::iterator it3 = it2->second.p.begin(); it3 != it2->second.p.end(); ++it3 ){
                 cout << it1->first << ' ' << it1->second.name << ' ';
                 cout << it2->first << ' ' << it2->second.name << ' ';
                 cout << it3->first << ' ' << it3->second.lastname << ' ' << it3->second.firstname << '\n';
             }
        }
     }


    return 0;
}

/*
2
1 School1
2 School2
4
1 1 11a
2 1 11b
3 2 11a
4 2 11b
7
1 1 Ivanov Ivan
2 1 Petrov Petr
3 2 Aleshin Aleksey
4 2 Vasiliev Vasiliy
5 3 Semenov Semen
6 3 Ivanov Petr
7 3 Petrov Semen

2
1 School1
2 School2
2
2 2 11b
1 2 11a
4
4 2 Vasiliev Vasiliy
1 1 Ivanov Ivan
3 2 Aleshin Aleksey
2 1 Petrov Petr
*/
