data = []
a = input()
while a != '.':
	data.append(a.split())
	a = input()
res = {}
changes = {}
bd = {}
for x, y in data:
	if y == 'BEGIN':
		changes[x] = set()
		bd[x] = {}
	elif y == 'COMMIT':
		for i in changes[x]:
			res[i] = bd[x][i]
	elif y == 'ROLLBACK':
		pass
	else:
		a, b = y.split('=')
		if '+' in b:
			b, c = b.split('+')
			if b in bd[x]:
				rr = bd[x][b]
			elif b in res:
				rr = res[b]
			else:
				rr = 0
			b = rr+int(c)
		else:
			b = int(b)
		changes[x].add(a)
		bd[x][a] = b
		if a not in res:
			res[a] = 0
for x, y in sorted(res.items()):
	print(f"{x}={y}")

'''
1 BEGIN
1 A=5
2 BEGIN
1 B=1
2 B=A+10
1 COMMIT
2 COMMIT
.

1 BEGIN
2 BEGIN
1 A=B+1
2 B=A+2
1 B=A+3
2 A=B+4
3 BEGIN
3 C=5
1 COMMIT
3 B=A+10
2 COMMIT
3 A=B+20
3 ROLLBACK
.
'''