#include <iostream>
#include <string>
#include <algorithm>
using namespace std;

#define SZ(sp) int(sp.size())

string alph = "0123456789ABCDEFGHIJKLMNOPQRSTUVWXYZ";

string to(int n, int d) {
    string ans = "";
    while (n) {
        ans += alph[n % d];
        n /= d;
    }
    reverse(ans.begin(), ans.end());
    return ans;
}

int from(string s, int d) {
    int ans = 0;
    for (int i = SZ(s) - 1, x = 1; i >= 0; --i) {
        ans += alph.find(s[i]) * x;
        x *= d;
    }
    return ans;
}

int main() {
    string s;
    cin >> s;
    string s2 = "";
    for (int i = 0; i < 4; ++i) {
        int n = alph.find(s[i]);
        string ss = to(n, 2);
        while (SZ(ss) < 4) {
            ss.insert(0, "0");
        }
        for (auto &el : ss) {
            el = alph[((el - '0') + 1) % 2];
        }
        s2 += ss;
    }
    int n = from(s2, 2) + 1;
    cout << to(n, 16);
}