#include <iostream>
#include <vector>
#include <string>
#include <map>
#include <cctype>
#include <algorithm>
#include <sstream>
using namespace std;

#define SZ(sp) int(sp.size())
#define all(sp) sp.begin(), sp.end()
#define mp make_pair
#define fi first
#define se second

int main() {
    vector < map < string, int > > proc(100);
    vector < pair < int, map < string, int > > > time;
    vector < int > start(100);
    time.emplace_back(0, map < string, int > ());
    string s;
    stringstream sx;
    int tt = 1;
    pair < int, map < string, int > > p = time[0];
    while (getline(cin, s)) {
        if (s == ".") {
            break;
        }
        int tr;
        string s_tr = "", req = "";
        for (int i = 0; i < SZ(s); ++i) {
            if (s[i] == ' ') {
                sx << s_tr;
                sx >> tr;
                sx.clear();
                for (int j = i + 1; j < SZ(s); ++j) {
                    req += s[j];
                }
                break;
            } else {
                s_tr += s[i];
            }
        }
        if (req == "BEGIN") {
            start[tr] = tt;
        } else if (req == "ROLLBACK") {
            proc[tr].clear();
        } else if (req == "COMMIT") {
            time.emplace_back(tt, time.back().second);
            for (auto &el : proc[tr]) {
                time.back().second[el.first] = el.second;
            }
            proc[tr].clear();
        } else {
            string name1 = "", name2 = "";
            int i = 0;
            for (; i < SZ(req); ++i) {
                if (req[i] == '=') {
                    ++i;
                    break;
                }
                name1 += req[i];
            }
            if (req.find("+") != std::string::npos) {
                for (; i < SZ(req); ++i) {
                    if (req[i] == '+') {
                        ++i;
                        break;
                    }
                    name2 += req[i];
                }
            }
            int cnt = 0;
            string s_cnt = "";
            for (; i < SZ(req); ++i) {
                s_cnt += req[i];
            }
            sx << s_cnt;
            sx >> cnt;
            sx.clear();
            if (SZ(name2) == 0) {
                if (time.back().second.find(name1) == time.back().second.end()) {
                    time.back().second[name1] = 0;
                }
                proc[tr][name1] = cnt;
            } else {
                if (time.back().second.find(name1) == time.back().second.end()) {
                    time.back().second[name1] = 0;
                }
                if (time.back().second.find(name1) == time.back().second.end()) {
                    time.back().second[name2] = 0;
                }
                int a = 0;
                if (proc[tr].find(name2) == proc[tr].end()) {
                    p.first = start[tr];
                    int pos = upper_bound(all(time), p) - time.begin();
                    --pos;
                    if (time[pos].second.find(name2) != time[pos].second.end()) {
                        a = time[pos].second[name2];
                    }
                } else {
                    a = proc[tr][name2];
                }
                proc[tr][name1] = a + cnt;
            }
        }
        ++tt;
    }
    for (auto &el : time.back().second) {
        cout << el.first << '=' << el.second << '\n';
    }
}
/*
1 BEGIN
1 A=5
2 BEGIN
1 B=1
2 B=A+10
1 COMMIT
2 COMMIT
.
*/

/*
1 BEGIN
2 BEGIN
1 A=B+1
2 B=A+2
1 B=A+3
2 A=B+4
3 BEGIN
3 C=5
1 COMMIT
3 B=A+10
2 COMMIT
3 A=B+20
3 ROLLBACK
.
*/
